//********************************************************************
//*** ResourcePool/oracle/oracleStatement.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: oracleStatement.cc,v 1.6 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "oracleStatement.hh"

#ifndef RESOURCEPOOL_ORACLE_ORACLEBIND_HH
#include "lex.oracle_bind.hh"
#endif

namespace fatalmind {
namespace oracle {

oracleStatement::oracleStatement(const std::string& SQL)
: _oraSQL()
{
	oracle_bind ora(SQL, _oraSQL);
}

const std::string& oracleStatement::getSQL() const {
	return _oraSQL;
}

bool operator<(const oracleStatement& lho, const oracleStatement& rho) 
{
	return lho._oraSQL < rho._oraSQL;
}

} // namespace oracle
} // namespace fatalmind
