//********************************************************************
//*** Thread/TaskRunner.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: TaskRunner.hh,v 1.18 2008/01/27 16:42:29 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef INCLUDED_TASKRUNNER_HH
#define INCLUDED_TASKRUNNER_HH

#include "Thread.hh"

//#include "Lock.hh"

//#include "Thread/Synchronize.hh"

#include "Thread/TaskRunnerInterface.hh"

#include "Exceptions/Exception.hh"
#include "mm/gc_ptr.hh"

#include "mm/CommonPtr.hh"

namespace fatalmind {

/* forward decl */

class TaskRunnerTask;

class TaskRunner: public Thread, public TaskRunnerInterface {
	public:
		TaskRunner();
		virtual ~TaskRunner();

		using TaskRunnerInterface::runDetached;
		void runDetached(CommonPtr<Task, MultiThreadedModel<> >);

		using TaskRunnerInterface::run;
		TaskRunnerInterface::ID run(CommonPtr<Task, MultiThreadedModel<> >);

		void stop();

		class Stopped: public Exception {
			public:
				Stopped(string msg);
		};

	private:
		TaskRunner(TaskRunner&); // c-ctor is hidden

		gc_ptr<TaskRunnerTask, MultiThreadedModel<> > _tsk;
};

} //namespace fatalmind

#endif
